package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.KwamaForagerEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class KwamaForagerRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(KwamaForagerEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelkwama_forager(), 0.5f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/kwama_forager_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelkwama_forager extends EntityModel<Entity> {
		private final ModelRenderer body;
		private final ModelRenderer face;
		private final ModelRenderer tail;

		public Modelkwama_forager() {
			textureWidth = 64;
			textureHeight = 64;
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 23.5F, 0.0F);
			body.setTextureOffset(0, 0).addBox(-5.0F, -7.5F, -8.0F, 10.0F, 8.0F, 10.0F, 0.0F, false);
			body.setTextureOffset(0, 18).addBox(-4.0F, -8.5F, -7.0F, 8.0F, 1.0F, 9.0F, 0.0F, false);
			face = new ModelRenderer(this);
			face.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(face);
			face.setTextureOffset(30, 0).addBox(-4.0F, -6.5F, -9.0F, 8.0F, 7.0F, 1.0F, 0.0F, false);
			face.setTextureOffset(0, 7).addBox(-1.0F, -2.275F, -9.35F, 2.0F, 2.0F, 1.0F, 0.0F, false);
			face.setTextureOffset(4, 18).addBox(1.75F, -4.775F, -9.35F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			face.setTextureOffset(6, 7).addBox(-0.45F, -4.775F, -9.35F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			face.setTextureOffset(0, 18).addBox(-2.75F, -4.775F, -9.35F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			tail = new ModelRenderer(this);
			tail.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(tail);
			tail.setTextureOffset(0, 28).addBox(-4.0F, -6.5F, 2.0F, 8.0F, 7.0F, 6.0F, 0.0F, false);
			tail.setTextureOffset(25, 18).addBox(-3.0F, -7.5F, 2.0F, 6.0F, 1.0F, 6.0F, 0.0F, false);
			tail.setTextureOffset(28, 28).addBox(-3.0F, -5.5F, 8.0F, 6.0F, 6.0F, 4.0F, 0.0F, false);
			tail.setTextureOffset(40, 8).addBox(-2.0F, -6.5F, 8.0F, 4.0F, 1.0F, 4.0F, 0.0F, false);
			tail.setTextureOffset(24, 38).addBox(-2.0F, -4.5F, 12.0F, 4.0F, 5.0F, 4.0F, 0.0F, false);
			tail.setTextureOffset(40, 13).addBox(-1.0F, -5.5F, 12.0F, 2.0F, 1.0F, 4.0F, 0.0F, false);
			tail.setTextureOffset(0, 0).addBox(-1.0F, -3.5F, 16.0F, 2.0F, 4.0F, 3.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			body.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.tail.rotateAngleY = MathHelper.cos(f * 0.6662F) * f1;
			this.body.rotateAngleY = MathHelper.cos(f * 0.6662F) * f1;
		}
	}

}
