package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.MatingKagoutiEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class MatingKagoutiRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(MatingKagoutiEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelkagouti_java(), 0.7999999999999999f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/kagouti_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelkagouti_java extends EntityModel<Entity> {
		private final ModelRenderer body;
		private final ModelRenderer tail_r1;
		private final ModelRenderer h_head;
		private final ModelRenderer jaw_r1;
		private final ModelRenderer head_frill_r1;
		private final ModelRenderer tusk_left_end_r1;
		private final ModelRenderer tusk_left_midd_r1;
		private final ModelRenderer tusk_left_front_back_r1;
		private final ModelRenderer tusk_left_end_r2;
		private final ModelRenderer tusk_left_midd_r2;
		private final ModelRenderer tusk_left_front_back_r2;
		private final ModelRenderer leg_left;
		private final ModelRenderer thaigh_left_r1;
		private final ModelRenderer leg_right;
		private final ModelRenderer thaigh_right_r1;

		public Modelkagouti_java() {
			textureWidth = 128;
			textureHeight = 128;
			body = new ModelRenderer(this);
			body.setRotationPoint(8.0F, -5.0F, 0.0F);
			body.setTextureOffset(0, 0).addBox(-18.0F, -5.0F, -13.0F, 20.0F, 17.0F, 26.0F, 0.0F, false);
			body.setTextureOffset(72, 73).addBox(-16.0F, -4.0F, 13.0F, 16.0F, 11.0F, 3.0F, 0.0F, false);
			body.setTextureOffset(28, 98).addBox(-15.0F, -2.0F, 16.0F, 14.0F, 9.0F, 3.0F, 0.0F, false);
			body.setTextureOffset(62, 101).addBox(-14.0F, 0.0F, 19.0F, 12.0F, 8.0F, 2.0F, 0.0F, false);
			body.setTextureOffset(97, 87).addBox(-12.0F, 2.0F, 21.0F, 8.0F, 6.0F, 2.0F, 0.0F, false);
			tail_r1 = new ModelRenderer(this);
			tail_r1.setRotationPoint(-8.0F, 6.0F, 23.0F);
			body.addChild(tail_r1);
			setRotationAngle(tail_r1, -0.4363F, 0.0F, 0.0F);
			tail_r1.setTextureOffset(48, 51).addBox(-2.0F, -2.0F, -1.0F, 4.0F, 4.0F, 4.0F, 0.0F, false);
			h_head = new ModelRenderer(this);
			h_head.setRotationPoint(0.0F, -3.0F, -13.0F);
			h_head.setTextureOffset(0, 43).addBox(-8.0F, -7.0F, -16.0F, 16.0F, 10.0F, 16.0F, 0.0F, false);
			h_head.setTextureOffset(108, 104).addBox(8.0F, -4.0F, -6.0F, 1.0F, 6.0F, 6.0F, 0.0F, false);
			h_head.setTextureOffset(0, 43).addBox(-9.0F, -4.0F, -6.0F, 1.0F, 6.0F, 6.0F, 0.0F, false);
			h_head.setTextureOffset(66, 13).addBox(-8.0F, -9.0F, -10.0F, 16.0F, 2.0F, 10.0F, 0.0F, false);
			h_head.setTextureOffset(16, 16).addBox(-1.0F, -9.0F, -16.0F, 2.0F, 2.0F, 2.0F, 0.0F, false);
			h_head.setTextureOffset(0, 16).addBox(-0.5F, -11.0F, -16.0F, 1.0F, 2.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(18, 2).addBox(6.5F, 4.5F, -17.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(18, 0).addBox(-7.5F, 4.5F, -17.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(0, 8).addBox(6.5F, 2.7F, -17.0F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			h_head.setTextureOffset(0, 0).addBox(-7.5F, 2.7F, -17.0F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			jaw_r1 = new ModelRenderer(this);
			jaw_r1.setRotationPoint(0.0F, 5.0F, 0.0F);
			h_head.addChild(jaw_r1);
			setRotationAngle(jaw_r1, 0.1309F, 0.0F, 0.0F);
			jaw_r1.setTextureOffset(47, 52).addBox(-8.0F, -2.0F, -17.0F, 16.0F, 4.0F, 17.0F, 0.0F, false);
			head_frill_r1 = new ModelRenderer(this);
			head_frill_r1.setRotationPoint(0.0F, -8.0F, 0.0F);
			h_head.addChild(head_frill_r1);
			setRotationAngle(head_frill_r1, 0.7854F, 0.0F, 0.0F);
			head_frill_r1.setTextureOffset(66, 0).addBox(-9.0F, -2.0F, -1.0F, 18.0F, 2.0F, 11.0F, 0.0F, false);
			tusk_left_end_r1 = new ModelRenderer(this);
			tusk_left_end_r1.setRotationPoint(-12.5F, -1.0F, -16.5F);
			h_head.addChild(tusk_left_end_r1);
			setRotationAngle(tusk_left_end_r1, 0.0F, -2.0944F, 0.0F);
			tusk_left_end_r1.setTextureOffset(0, 0).addBox(-5.4F, -2.0F, -2.0F, 7.0F, 4.0F, 4.0F, -1.0F, false);
			tusk_left_midd_r1 = new ModelRenderer(this);
			tusk_left_midd_r1.setRotationPoint(-12.0F, 0.0F, -5.0F);
			h_head.addChild(tusk_left_midd_r1);
			setRotationAngle(tusk_left_midd_r1, 0.0F, -1.5708F, 0.0F);
			tusk_left_midd_r1.setTextureOffset(48, 43).addBox(-11.9F, -3.0F, -1.5F, 13.0F, 4.0F, 4.0F, -0.4F, false);
			tusk_left_front_back_r1 = new ModelRenderer(this);
			tusk_left_front_back_r1.setRotationPoint(-8.0F, 0.0F, -4.0F);
			h_head.addChild(tusk_left_front_back_r1);
			setRotationAngle(tusk_left_front_back_r1, 0.0F, -0.48F, 0.0F);
			tusk_left_front_back_r1.setTextureOffset(0, 16).addBox(-5.65F, -3.0F, -1.0F, 6.0F, 4.0F, 4.0F, 0.0F, false);
			tusk_left_end_r2 = new ModelRenderer(this);
			tusk_left_end_r2.setRotationPoint(12.5F, -1.0F, -16.5F);
			h_head.addChild(tusk_left_end_r2);
			setRotationAngle(tusk_left_end_r2, 0.0F, 2.0944F, 0.0F);
			tusk_left_end_r2.setTextureOffset(0, 8).addBox(-1.6F, -2.0F, -2.0F, 7.0F, 4.0F, 4.0F, -1.0F, false);
			tusk_left_midd_r2 = new ModelRenderer(this);
			tusk_left_midd_r2.setRotationPoint(12.0F, 0.0F, -5.0F);
			h_head.addChild(tusk_left_midd_r2);
			setRotationAngle(tusk_left_midd_r2, 0.0F, 1.5708F, 0.0F);
			tusk_left_midd_r2.setTextureOffset(92, 25).addBox(-1.1F, -3.0F, -1.5F, 13.0F, 4.0F, 4.0F, -0.4F, false);
			tusk_left_front_back_r2 = new ModelRenderer(this);
			tusk_left_front_back_r2.setRotationPoint(8.0F, 0.0F, -4.0F);
			h_head.addChild(tusk_left_front_back_r2);
			setRotationAngle(tusk_left_front_back_r2, 0.0F, 0.48F, 0.0F);
			tusk_left_front_back_r2.setTextureOffset(26, 69).addBox(-0.35F, -3.0F, -1.0F, 6.0F, 4.0F, 4.0F, 0.0F, false);
			leg_left = new ModelRenderer(this);
			leg_left.setRotationPoint(9.0F, -1.0F, 3.0F);
			leg_left.setTextureOffset(96, 48).addBox(2.0F, 9.0F, -6.0F, 6.0F, 11.0F, 8.0F, 0.0F, false);
			leg_left.setTextureOffset(72, 87).addBox(1.0F, 20.0F, -7.0F, 8.0F, 5.0F, 9.0F, 0.0F, false);
			leg_left.setTextureOffset(108, 13).addBox(1.0F, 21.0F, -9.0F, 8.0F, 4.0F, 2.0F, 0.0F, false);
			leg_left.setTextureOffset(37, 110).addBox(7.0F, 23.0F, -14.0F, 2.0F, 2.0F, 5.0F, 0.0F, false);
			leg_left.setTextureOffset(23, 110).addBox(1.0F, 23.0F, -14.0F, 2.0F, 2.0F, 5.0F, 0.0F, false);
			leg_left.setTextureOffset(83, 104).addBox(4.0F, 23.0F, -16.0F, 2.0F, 2.0F, 7.0F, 0.0F, false);
			thaigh_left_r1 = new ModelRenderer(this);
			thaigh_left_r1.setRotationPoint(2.0F, -1.0F, 1.0F);
			leg_left.addChild(thaigh_left_r1);
			setRotationAngle(thaigh_left_r1, -0.2618F, 0.0F, 0.0F);
			thaigh_left_r1.setTextureOffset(36, 73).addBox(-1.0F, -2.8625F, -5.6402F, 8.0F, 15.0F, 10.0F, 0.0F, false);
			leg_right = new ModelRenderer(this);
			leg_right.setRotationPoint(-10.0F, -2.0F, 4.0F);
			leg_right.setTextureOffset(0, 94).addBox(-7.0F, 10.0F, -7.0F, 6.0F, 11.0F, 8.0F, 0.0F, false);
			leg_right.setTextureOffset(83, 34).addBox(-8.0F, 21.0F, -8.0F, 8.0F, 5.0F, 9.0F, 0.0F, false);
			leg_right.setTextureOffset(94, 104).addBox(-8.0F, 22.0F, -10.0F, 8.0F, 4.0F, 2.0F, 0.0F, false);
			leg_right.setTextureOffset(108, 68).addBox(-2.0F, 24.0F, -15.0F, 2.0F, 2.0F, 5.0F, 0.0F, false);
			leg_right.setTextureOffset(108, 33).addBox(-8.0F, 24.0F, -15.0F, 2.0F, 2.0F, 5.0F, 0.0F, false);
			leg_right.setTextureOffset(99, 95).addBox(-5.0F, 24.0F, -17.0F, 2.0F, 2.0F, 7.0F, 0.0F, false);
			thaigh_right_r1 = new ModelRenderer(this);
			thaigh_right_r1.setRotationPoint(0.0F, 1.0F, -4.0F);
			leg_right.addChild(thaigh_right_r1);
			setRotationAngle(thaigh_right_r1, -0.2618F, 0.0F, 0.0F);
			thaigh_right_r1.setTextureOffset(0, 69).addBox(-8.0F, -4.8637F, -2.0353F, 8.0F, 15.0F, 10.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			h_head.render(matrixStack, buffer, packedLight, packedOverlay);
			leg_left.render(matrixStack, buffer, packedLight, packedOverlay);
			leg_right.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.leg_right.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.h_head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.h_head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.leg_left.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}

}
