package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.MorrowindFrogEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class MorrowindFrogRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(MorrowindFrogEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelfrog_java(), 0.5f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/frog_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelfrog_java extends EntityModel<Entity> {
		private final ModelRenderer h_head;
		private final ModelRenderer body;
		private final ModelRenderer body_r1;
		private final ModelRenderer left_front_leg;
		private final ModelRenderer left_back_leg_end_r1;
		private final ModelRenderer left_front_leg_top_r1;
		private final ModelRenderer left_front_leg_top_r2;
		private final ModelRenderer left_back_leg;
		private final ModelRenderer right_toe_back_left_r1;
		private final ModelRenderer left_toe_back_left_r1;
		private final ModelRenderer left_back_leg_end_r2;
		private final ModelRenderer left_back_leg_end_r3;
		private final ModelRenderer left_back_leg_top_r1;
		private final ModelRenderer left_back_leg_midd_r1;
		private final ModelRenderer right_front_leg;
		private final ModelRenderer right_back_leg_end_r1;
		private final ModelRenderer right_front_leg_top_r1;
		private final ModelRenderer right_front_leg_top_r2;
		private final ModelRenderer right_back_leg;
		private final ModelRenderer right_toe_back_right_r1;
		private final ModelRenderer left_toe_back_right_r1;
		private final ModelRenderer right_back_leg_end_r2;
		private final ModelRenderer right_back_leg_end_r3;
		private final ModelRenderer right_back_leg_top_r1;
		private final ModelRenderer right_back_leg_midd_r1;

		public Modelfrog_java() {
			textureWidth = 32;
			textureHeight = 32;
			h_head = new ModelRenderer(this);
			h_head.setRotationPoint(0.0F, 22.0F, -2.0F);
			h_head.setTextureOffset(0, 6).addBox(-1.1F, -1.25F, -0.8F, 2.0F, 2.0F, 2.0F, -0.2F, false);
			h_head.setTextureOffset(10, 16).addBox(0.0F, -1.75F, -0.55F, 1.0F, 1.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(4, 16).addBox(-1.2F, -1.75F, -0.55F, 1.0F, 1.0F, 1.0F, -0.3F, false);
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 22.0F, -2.0F);
			body_r1 = new ModelRenderer(this);
			body_r1.setRotationPoint(0.4F, 0.0F, 2.2F);
			body.addChild(body_r1);
			setRotationAngle(body_r1, -0.0873F, 0.0F, 0.0F);
			body_r1.setTextureOffset(0, 0).addBox(-2.0F, -1.0F, -2.0F, 3.0F, 2.0F, 4.0F, -0.3F, false);
			left_front_leg = new ModelRenderer(this);
			left_front_leg.setRotationPoint(0.75F, 22.0F, -2.0F);
			left_front_leg.setTextureOffset(16, 3).addBox(0.15F, 1.425F, -0.025F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			left_front_leg.setTextureOffset(0, 16).addBox(-0.35F, 1.425F, -0.025F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			left_back_leg_end_r1 = new ModelRenderer(this);
			left_back_leg_end_r1.setRotationPoint(0.4F, 1.6F, 0.95F);
			left_front_leg.addChild(left_back_leg_end_r1);
			setRotationAngle(left_back_leg_end_r1, -1.5708F, 0.0F, 0.0F);
			left_back_leg_end_r1.setTextureOffset(14, 10).addBox(-0.5F, -0.3F, -0.35F, 1.0F, 1.0F, 1.0F, -0.26F, false);
			left_front_leg_top_r1 = new ModelRenderer(this);
			left_front_leg_top_r1.setRotationPoint(0.4F, 0.75F, 1.7F);
			left_front_leg.addChild(left_front_leg_top_r1);
			setRotationAngle(left_front_leg_top_r1, -0.6981F, 0.0F, 0.0F);
			left_front_leg_top_r1.setTextureOffset(4, 11).addBox(-0.5F, -0.2817F, -0.4981F, 1.0F, 2.0F, 1.0F, -0.25F, false);
			left_front_leg_top_r2 = new ModelRenderer(this);
			left_front_leg_top_r2.setRotationPoint(-0.35F, 0.0F, 0.7F);
			left_front_leg.addChild(left_front_leg_top_r2);
			setRotationAngle(left_front_leg_top_r2, 0.8727F, 0.0F, 0.0F);
			left_front_leg_top_r2.setTextureOffset(13, 5).addBox(0.25F, -0.35F, -0.25F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			left_back_leg = new ModelRenderer(this);
			left_back_leg.setRotationPoint(0.5F, 22.1F, 0.25F);
			setRotationAngle(left_back_leg, 0.5672F, 0.0F, 0.0F);
			right_toe_back_left_r1 = new ModelRenderer(this);
			right_toe_back_left_r1.setRotationPoint(0.1F, 0.8F, -2.0F);
			left_back_leg.addChild(right_toe_back_left_r1);
			setRotationAngle(right_toe_back_left_r1, -0.5672F, 0.0F, 0.0F);
			right_toe_back_left_r1.setTextureOffset(7, 15).addBox(-0.2F, -0.4247F, 0.5556F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			left_toe_back_left_r1 = new ModelRenderer(this);
			left_toe_back_left_r1.setRotationPoint(0.45F, 0.9F, -2.0F);
			left_back_leg.addChild(left_toe_back_left_r1);
			setRotationAngle(left_toe_back_left_r1, -0.5672F, 0.0F, 0.0F);
			left_toe_back_left_r1.setTextureOffset(15, 8).addBox(-0.05F, -0.5091F, 0.5019F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			left_back_leg_end_r2 = new ModelRenderer(this);
			left_back_leg_end_r2.setRotationPoint(0.25F, 1.0F, -1.75F);
			left_back_leg.addChild(left_back_leg_end_r2);
			setRotationAngle(left_back_leg_end_r2, -2.138F, 0.0F, 0.0F);
			left_back_leg_end_r2.setTextureOffset(13, 15).addBox(-0.1F, -1.5543F, -0.6195F, 1.0F, 1.0F, 1.0F, -0.25F, false);
			left_back_leg_end_r3 = new ModelRenderer(this);
			left_back_leg_end_r3.setRotationPoint(0.25F, 1.0F, -0.75F);
			left_back_leg.addChild(left_back_leg_end_r3);
			setRotationAngle(left_back_leg_end_r3, -1.3526F, 0.0F, 0.0F);
			left_back_leg_end_r3.setTextureOffset(10, 11).addBox(-0.1F, -1.6513F, 0.1405F, 1.0F, 2.0F, 1.0F, -0.23F, false);
			left_back_leg_top_r1 = new ModelRenderer(this);
			left_back_leg_top_r1.setRotationPoint(0.0F, -0.25F, 0.0F);
			left_back_leg.addChild(left_back_leg_top_r1);
			setRotationAngle(left_back_leg_top_r1, 1.3963F, 0.0F, 0.0F);
			left_back_leg_top_r1.setTextureOffset(11, 8).addBox(0.15F, -0.2913F, -0.9592F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			left_back_leg_midd_r1 = new ModelRenderer(this);
			left_back_leg_midd_r1.setRotationPoint(0.25F, -0.25F, -1.0F);
			left_back_leg.addChild(left_back_leg_midd_r1);
			setRotationAngle(left_back_leg_midd_r1, 0.48F, 0.0F, 0.0F);
			left_back_leg_midd_r1.setTextureOffset(0, 13).addBox(-0.1F, 0.701F, 0.137F, 1.0F, 2.0F, 1.0F, -0.21F, false);
			right_front_leg = new ModelRenderer(this);
			right_front_leg.setRotationPoint(-1.75F, 22.0F, -2.0F);
			right_front_leg.setTextureOffset(10, 14).addBox(0.15F, 1.425F, -0.025F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			right_front_leg.setTextureOffset(14, 0).addBox(-0.35F, 1.425F, -0.025F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			right_back_leg_end_r1 = new ModelRenderer(this);
			right_back_leg_end_r1.setRotationPoint(0.4F, 1.6F, 0.95F);
			right_front_leg.addChild(right_back_leg_end_r1);
			setRotationAngle(right_back_leg_end_r1, -1.5708F, 0.0F, 0.0F);
			right_back_leg_end_r1.setTextureOffset(4, 14).addBox(-0.5F, -0.3F, -0.35F, 1.0F, 1.0F, 1.0F, -0.26F, false);
			right_front_leg_top_r1 = new ModelRenderer(this);
			right_front_leg_top_r1.setRotationPoint(0.4F, 0.75F, 1.7F);
			right_front_leg.addChild(right_front_leg_top_r1);
			setRotationAngle(right_front_leg_top_r1, -0.6981F, 0.0F, 0.0F);
			right_front_leg_top_r1.setTextureOffset(0, 10).addBox(-0.5F, -0.2817F, -0.4981F, 1.0F, 2.0F, 1.0F, -0.25F, false);
			right_front_leg_top_r2 = new ModelRenderer(this);
			right_front_leg_top_r2.setRotationPoint(-0.35F, 0.0F, 0.7F);
			right_front_leg.addChild(right_front_leg_top_r2);
			setRotationAngle(right_front_leg_top_r2, 0.8727F, 0.0F, 0.0F);
			right_front_leg_top_r2.setTextureOffset(10, 0).addBox(0.25F, -0.35F, -0.25F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			right_back_leg = new ModelRenderer(this);
			right_back_leg.setRotationPoint(-1.75F, 22.1F, 0.25F);
			setRotationAngle(right_back_leg, 0.5672F, 0.0F, 0.0F);
			right_toe_back_right_r1 = new ModelRenderer(this);
			right_toe_back_right_r1.setRotationPoint(-0.15F, 0.8F, -2.0F);
			right_back_leg.addChild(right_toe_back_right_r1);
			setRotationAngle(right_toe_back_right_r1, -0.5672F, 0.0F, 0.0F);
			right_toe_back_right_r1.setTextureOffset(13, 2).addBox(-0.2F, -0.4247F, 0.5556F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			left_toe_back_right_r1 = new ModelRenderer(this);
			left_toe_back_right_r1.setRotationPoint(0.2F, 0.9F, -2.0F);
			right_back_leg.addChild(left_toe_back_right_r1);
			setRotationAngle(left_toe_back_right_r1, -0.5672F, 0.0F, 0.0F);
			left_toe_back_right_r1.setTextureOffset(7, 13).addBox(-0.05F, -0.5091F, 0.5019F, 1.0F, 1.0F, 1.0F, -0.4F, false);
			right_back_leg_end_r2 = new ModelRenderer(this);
			right_back_leg_end_r2.setRotationPoint(0.0F, 1.0F, -1.75F);
			right_back_leg.addChild(right_back_leg_end_r2);
			setRotationAngle(right_back_leg_end_r2, -2.138F, 0.0F, 0.0F);
			right_back_leg_end_r2.setTextureOffset(13, 13).addBox(-0.1F, -1.5543F, -0.6195F, 1.0F, 1.0F, 1.0F, -0.25F, false);
			right_back_leg_end_r3 = new ModelRenderer(this);
			right_back_leg_end_r3.setRotationPoint(0.0F, 1.0F, -0.75F);
			right_back_leg.addChild(right_back_leg_end_r3);
			setRotationAngle(right_back_leg_end_r3, -1.3526F, 0.0F, 0.0F);
			right_back_leg_end_r3.setTextureOffset(0, 0).addBox(-0.1F, -1.6513F, 0.1405F, 1.0F, 2.0F, 1.0F, -0.23F, false);
			right_back_leg_top_r1 = new ModelRenderer(this);
			right_back_leg_top_r1.setRotationPoint(0.0F, -0.25F, 0.0F);
			right_back_leg.addChild(right_back_leg_top_r1);
			setRotationAngle(right_back_leg_top_r1, 1.3963F, 0.0F, 0.0F);
			right_back_leg_top_r1.setTextureOffset(8, 6).addBox(-0.1F, -0.2913F, -0.9592F, 1.0F, 2.0F, 1.0F, -0.2F, false);
			right_back_leg_midd_r1 = new ModelRenderer(this);
			right_back_leg_midd_r1.setRotationPoint(0.0F, -0.25F, -1.0F);
			right_back_leg.addChild(right_back_leg_midd_r1);
			setRotationAngle(right_back_leg_midd_r1, 0.48F, 0.0F, 0.0F);
			right_back_leg_midd_r1.setTextureOffset(7, 9).addBox(-0.1F, 0.701F, 0.137F, 1.0F, 2.0F, 1.0F, -0.21F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			h_head.render(matrixStack, buffer, packedLight, packedOverlay);
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			left_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			left_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			right_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			right_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.right_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.left_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.h_head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.h_head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.left_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.right_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}

}
