package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.RogueNixHoundEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class RogueNixHoundRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(RogueNixHoundEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelnix_hound(), 0.5f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/nix_hound_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelnix_hound extends EntityModel<Entity> {
		private final ModelRenderer nix_hound;
		private final ModelRenderer body;
		private final ModelRenderer back;
		private final ModelRenderer back_end_bit_r1;
		private final ModelRenderer neck;
		private final ModelRenderer h_head;
		private final ModelRenderer left_front_leg;
		private final ModelRenderer right_front_leg;
		private final ModelRenderer l_back_leg;
		private final ModelRenderer r_back_leg;
		private final ModelRenderer leg_hips;

		public Modelnix_hound() {
			textureWidth = 128;
			textureHeight = 128;
			nix_hound = new ModelRenderer(this);
			nix_hound.setRotationPoint(-3.5F, 3.5F, 5.5F);
			body = new ModelRenderer(this);
			body.setRotationPoint(-0.5F, 4.5F, 4.5F);
			body.setTextureOffset(0, 0).addBox(-5.5F, -4.5F, -15.5F, 11.0F, 9.0F, 11.0F, 0.0F, false);
			body.setTextureOffset(0, 32).addBox(-4.5F, -3.5F, -4.5F, 9.0F, 8.0F, 6.0F, 0.0F, false);
			body.setTextureOffset(0, 20).addBox(-4.5F, 4.5F, -15.5F, 9.0F, 1.0F, 11.0F, 0.0F, false);
			back = new ModelRenderer(this);
			back.setRotationPoint(-0.5F, 5.5F, 17.5F);
			back.setTextureOffset(41, 17).addBox(-5.5F, -5.5F, -11.5F, 11.0F, 10.0F, 3.0F, 0.0F, false);
			back.setTextureOffset(0, 46).addBox(-5.5F, -6.5F, -8.5F, 11.0F, 11.0F, 2.0F, 0.0F, false);
			back.setTextureOffset(30, 32).addBox(-5.5F, -7.5F, -6.5F, 11.0F, 12.0F, 3.0F, 0.0F, false);
			back.setTextureOffset(44, 0).addBox(-5.5F, -6.5F, -3.5F, 11.0F, 11.0F, 2.0F, 0.0F, false);
			back.setTextureOffset(52, 47).addBox(-5.5F, -5.5F, -1.5F, 11.0F, 9.0F, 2.0F, 0.0F, false);
			back.setTextureOffset(67, 37).addBox(-3.5F, -3.5F, 0.5F, 7.0F, 6.0F, 1.0F, 0.0F, false);
			back.setTextureOffset(0, 6).addBox(-1.5F, -2.5F, 1.5F, 3.0F, 4.0F, 1.0F, 0.0F, false);
			back_end_bit_r1 = new ModelRenderer(this);
			back_end_bit_r1.setRotationPoint(0.0F, -0.5F, 2.0F);
			back.addChild(back_end_bit_r1);
			setRotationAngle(back_end_bit_r1, -0.7854F, 0.0F, 0.0F);
			back_end_bit_r1.setTextureOffset(0, 32).addBox(-0.5F, -1.7071F, -0.7929F, 1.0F, 2.0F, 2.0F, 0.0F, false);
			neck = new ModelRenderer(this);
			neck.setRotationPoint(-0.5F, 5.0F, -7.5F);
			neck.setTextureOffset(24, 58).addBox(-4.5F, -4.0F, -5.5F, 9.0F, 9.0F, 2.0F, 0.0F, false);
			h_head = new ModelRenderer(this);
			h_head.setRotationPoint(-0.5F, 4.5F, -15.0F);
			h_head.setTextureOffset(26, 47).addBox(-3.5F, -1.5761F, -3.8827F, 7.0F, 5.0F, 6.0F, 0.0F, false);
			h_head.setTextureOffset(0, 67).addBox(-2.5F, -1.5454F, -5.6872F, 5.0F, 5.0F, 3.0F, 0.0F, false);
			h_head.setTextureOffset(0, 0).addBox(-1.5F, -0.5451F, -7.6502F, 3.0F, 4.0F, 2.0F, 0.0F, false);
			h_head.setTextureOffset(0, 24).addBox(-1.5F, 0.4637F, -8.4936F, 3.0F, 3.0F, 1.0F, -0.1F, false);
			h_head.setTextureOffset(0, 20).addBox(-1.25F, 1.2137F, -10.1936F, 2.0F, 2.0F, 2.0F, -0.2F, false);
			h_head.setTextureOffset(37, 3).addBox(-0.5F, 1.9637F, -11.7936F, 1.0F, 1.0F, 2.0F, -0.2F, false);
			h_head.setTextureOffset(7, 23).addBox(-3.5F, -0.3973F, -4.9155F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(6, 20).addBox(2.5F, -0.3973F, -4.9155F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(33, 0).addBox(2.25F, 2.5381F, -4.1913F, 1.0F, 7.0F, 1.0F, -0.1F, false);
			h_head.setTextureOffset(77, 5).addBox(-3.25F, 8.425F, -8.25F, 1.0F, 1.0F, 5.0F, -0.2F, false);
			h_head.setTextureOffset(77, 11).addBox(2.25F, 8.675F, -8.25F, 1.0F, 1.0F, 5.0F, -0.2F, false);
			h_head.setTextureOffset(29, 20).addBox(-3.25F, 2.2881F, -4.1913F, 1.0F, 7.0F, 1.0F, -0.1F, false);
			h_head.setTextureOffset(58, 30).addBox(-2.5F, -2.55F, -3.95F, 5.0F, 1.0F, 6.0F, 0.0F, false);
			left_front_leg = new ModelRenderer(this);
			left_front_leg.setRotationPoint(4.0F, 4.0F, -2.0F);
			left_front_leg.setTextureOffset(58, 58).addBox(0.0F, -1.0F, -5.0F, 3.0F, 10.0F, 3.0F, 0.0F, false);
			left_front_leg.setTextureOffset(16, 70).addBox(0.0F, 6.0F, -4.5F, 2.0F, 13.0F, 2.0F, -0.1F, false);
			left_front_leg.setTextureOffset(77, 54).addBox(0.0F, 18.0F, -6.0F, 2.0F, 1.0F, 4.0F, 0.0F, false);
			left_front_leg.setTextureOffset(44, 13).addBox(1.5F, 19.0F, -7.0F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			left_front_leg.setTextureOffset(37, 6).addBox(-0.5F, 19.0F, -7.0F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			left_front_leg.setTextureOffset(13, 62).addBox(0.5F, 19.0F, -9.0F, 1.0F, 1.0F, 7.0F, 0.0F, false);
			right_front_leg = new ModelRenderer(this);
			right_front_leg.setRotationPoint(-6.5F, 3.5F, -1.5F);
			right_front_leg.setTextureOffset(46, 58).addBox(-1.5F, -0.5F, -5.5F, 3.0F, 10.0F, 3.0F, 0.0F, false);
			right_front_leg.setTextureOffset(47, 71).addBox(-0.5F, 7.5F, -5.0F, 2.0F, 12.0F, 2.0F, -0.1F, false);
			right_front_leg.setTextureOffset(77, 0).addBox(-0.5F, 18.5F, -6.5F, 2.0F, 1.0F, 4.0F, 0.0F, false);
			right_front_leg.setTextureOffset(0, 59).addBox(0.0F, 19.5F, -9.5F, 1.0F, 1.0F, 7.0F, 0.0F, false);
			right_front_leg.setTextureOffset(37, 0).addBox(1.0F, 19.5F, -7.5F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			right_front_leg.setTextureOffset(24, 35).addBox(-1.0F, 19.5F, -7.5F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			l_back_leg = new ModelRenderer(this);
			l_back_leg.setRotationPoint(4.5F, 6.5F, 10.5F);
			l_back_leg.setTextureOffset(35, 69).addBox(-0.5F, -2.5F, -2.5F, 3.0F, 8.0F, 3.0F, 0.0F, false);
			l_back_leg.setTextureOffset(76, 76).addBox(-0.5F, 2.55F, 0.5F, 3.0F, 3.0F, 3.0F, 0.0F, false);
			l_back_leg.setTextureOffset(27, 69).addBox(-0.5F, 3.0F, 1.0F, 2.0F, 13.0F, 2.0F, -0.1F, false);
			l_back_leg.setTextureOffset(76, 44).addBox(-0.5F, 15.5F, -0.75F, 2.0F, 1.0F, 4.0F, 0.0F, false);
			l_back_leg.setTextureOffset(58, 37).addBox(0.0F, 16.5F, -3.75F, 1.0F, 1.0F, 7.0F, 0.0F, false);
			l_back_leg.setTextureOffset(33, 20).addBox(1.0F, 16.5F, -1.75F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			l_back_leg.setTextureOffset(33, 8).addBox(-1.0F, 16.5F, -1.75F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			r_back_leg = new ModelRenderer(this);
			r_back_leg.setRotationPoint(-6.5F, 4.5F, 13.0F);
			r_back_leg.setTextureOffset(67, 68).addBox(-1.5F, -0.5F, -5.0F, 3.0F, 8.0F, 3.0F, 0.0F, false);
			r_back_leg.setTextureOffset(0, 75).addBox(-1.5F, 4.4673F, -1.9761F, 3.0F, 3.0F, 3.0F, 0.0F, false);
			r_back_leg.setTextureOffset(69, 11).addBox(-0.5F, 5.0F, -1.5F, 2.0F, 13.0F, 2.0F, -0.1F, false);
			r_back_leg.setTextureOffset(74, 31).addBox(-0.5F, 17.5F, -3.25F, 2.0F, 1.0F, 4.0F, 0.0F, false);
			r_back_leg.setTextureOffset(29, 23).addBox(0.0F, 18.5F, -6.25F, 1.0F, 1.0F, 7.0F, 0.0F, false);
			r_back_leg.setTextureOffset(24, 32).addBox(1.0F, 18.5F, -4.25F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			r_back_leg.setTextureOffset(0, 28).addBox(-1.0F, 18.5F, -4.25F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			leg_hips = new ModelRenderer(this);
			leg_hips.setRotationPoint(-0.5F, 6.5F, 4.5F);
			leg_hips.setTextureOffset(70, 0).addBox(-6.5F, -3.5F, 2.5F, 1.0F, 5.0F, 5.0F, 0.0F, false);
			leg_hips.setTextureOffset(70, 58).addBox(5.5F, -3.5F, 2.5F, 1.0F, 5.0F, 5.0F, 0.0F, false);
			leg_hips.setTextureOffset(55, 71).addBox(-6.5F, -4.5F, -12.5F, 1.0F, 5.0F, 5.0F, 0.0F, false);
			leg_hips.setTextureOffset(74, 21).addBox(5.5F, -4.5F, -12.5F, 1.0F, 5.0F, 5.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			nix_hound.render(matrixStack, buffer, packedLight, packedOverlay);
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			back.render(matrixStack, buffer, packedLight, packedOverlay);
			neck.render(matrixStack, buffer, packedLight, packedOverlay);
			h_head.render(matrixStack, buffer, packedLight, packedOverlay);
			left_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			right_front_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			l_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			r_back_leg.render(matrixStack, buffer, packedLight, packedOverlay);
			leg_hips.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.right_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.h_head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.h_head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.l_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.r_back_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.left_front_leg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}

}
