package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.ScribEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class ScribRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(ScribEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new ModelScrib_java(), 0.5f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/scrib_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class ModelScrib_java extends EntityModel<Entity> {
		private final ModelRenderer h_head;
		private final ModelRenderer jaw_r1;
		private final ModelRenderer snout_r1;
		private final ModelRenderer head_spike_r1;
		private final ModelRenderer head_spike_r2;
		private final ModelRenderer head_spike_r3;
		private final ModelRenderer head_spike_r4;
		private final ModelRenderer head_r1;
		private final ModelRenderer head_plate_r1;
		private final ModelRenderer body;
		private final ModelRenderer legs_right;
		private final ModelRenderer leg_fron_right_r1;
		private final ModelRenderer leg_fron_right_r2;
		private final ModelRenderer leg_fron_right_r3;
		private final ModelRenderer leg_fron_right_r4;
		private final ModelRenderer legs_left;
		private final ModelRenderer leg_fron_left_r1;
		private final ModelRenderer leg_fron_left_r2;
		private final ModelRenderer leg_fron_left_r3;
		private final ModelRenderer leg_fron_left_r4;

		public ModelScrib_java() {
			textureWidth = 64;
			textureHeight = 64;
			h_head = new ModelRenderer(this);
			h_head.setRotationPoint(0.0F, 19.5F, -6.25F);
			setRotationAngle(h_head, -0.1745F, 0.0F, 0.0F);
			jaw_r1 = new ModelRenderer(this);
			jaw_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			h_head.addChild(jaw_r1);
			setRotationAngle(jaw_r1, -0.3491F, 0.0F, 0.0F);
			jaw_r1.setTextureOffset(14, 13).addBox(-3.0F, 0.0F, -0.75F, 5.0F, 3.0F, 1.0F, 0.0F, false);
			snout_r1 = new ModelRenderer(this);
			snout_r1.setRotationPoint(0.0F, -1.0F, -2.0F);
			h_head.addChild(snout_r1);
			setRotationAngle(snout_r1, -0.4363F, 0.0F, 0.0F);
			snout_r1.setTextureOffset(0, 13).addBox(-3.0F, 0.0611F, -0.5148F, 5.0F, 3.0F, 2.0F, 0.0F, false);
			head_spike_r1 = new ModelRenderer(this);
			head_spike_r1.setRotationPoint(-2.0F, -1.0F, -1.0F);
			h_head.addChild(head_spike_r1);
			setRotationAngle(head_spike_r1, -0.4363F, 0.0F, 0.0F);
			head_spike_r1.setTextureOffset(8, 18).addBox(-0.85F, -0.5163F, -0.4211F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_spike_r2 = new ModelRenderer(this);
			head_spike_r2.setRotationPoint(1.0F, -1.0F, -0.75F);
			h_head.addChild(head_spike_r2);
			setRotationAngle(head_spike_r2, -0.4363F, 0.0F, 0.0F);
			head_spike_r2.setTextureOffset(4, 29).addBox(-0.2F, -0.4107F, -0.6477F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_spike_r3 = new ModelRenderer(this);
			head_spike_r3.setRotationPoint(-2.0F, -1.75F, -0.25F);
			h_head.addChild(head_spike_r3);
			setRotationAngle(head_spike_r3, -0.4363F, 0.0F, 0.0F);
			head_spike_r3.setTextureOffset(28, 23).addBox(-0.8F, -0.5196F, -0.5338F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_spike_r3.setTextureOffset(14, 29).addBox(2.8F, -0.5196F, -0.5338F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_spike_r4 = new ModelRenderer(this);
			head_spike_r4.setRotationPoint(-2.0F, -2.5F, 0.25F);
			h_head.addChild(head_spike_r4);
			setRotationAngle(head_spike_r4, -0.4363F, 0.0F, 0.0F);
			head_spike_r4.setTextureOffset(0, 29).addBox(-0.8F, -0.6286F, -0.42F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_spike_r4.setTextureOffset(29, 16).addBox(2.8F, -0.6286F, -0.42F, 1.0F, 1.0F, 1.0F, -0.2F, false);
			head_r1 = new ModelRenderer(this);
			head_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			h_head.addChild(head_r1);
			setRotationAngle(head_r1, -0.4363F, 0.0F, 0.0F);
			head_r1.setTextureOffset(12, 17).addBox(-2.0F, -3.0F, -1.75F, 3.0F, 3.0F, 2.0F, 0.0F, false);
			head_plate_r1 = new ModelRenderer(this);
			head_plate_r1.setRotationPoint(0.0F, -2.0F, -1.0F);
			h_head.addChild(head_plate_r1);
			setRotationAngle(head_plate_r1, -0.4363F, 0.0F, 0.0F);
			head_plate_r1.setTextureOffset(16, 0).addBox(-3.0F, -1.61F, -0.9985F, 5.0F, 3.0F, 1.0F, 0.0F, false);
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 20.25F, -2.25F);
			body.setTextureOffset(0, 0).addBox(-3.0F, -2.75F, -2.9F, 5.0F, 4.0F, 3.0F, -0.2F, false);
			body.setTextureOffset(16, 9).addBox(-2.0F, -1.75F, -4.7F, 3.0F, 2.0F, 2.0F, -0.001F, false);
			body.setTextureOffset(0, 7).addBox(-3.0F, -1.75F, -0.225F, 5.0F, 3.0F, 3.0F, -0.13F, false);
			body.setTextureOffset(13, 4).addBox(-2.0F, -0.85F, 2.65F, 3.0F, 2.0F, 3.0F, 0.0F, false);
			body.setTextureOffset(0, 18).addBox(-2.0F, -0.1F, 5.65F, 3.0F, 1.0F, 2.0F, 0.0F, false);
			legs_right = new ModelRenderer(this);
			legs_right.setRotationPoint(-2.75F, 19.5F, -2.5F);
			leg_fron_right_r1 = new ModelRenderer(this);
			leg_fron_right_r1.setRotationPoint(-2.75F, 2.25F, 2.6F);
			legs_right.addChild(leg_fron_right_r1);
			setRotationAngle(leg_fron_right_r1, 0.0F, 0.0F, -1.5708F);
			leg_fron_right_r1.setTextureOffset(24, 8).addBox(-2.575F, -0.55F, -0.5F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_right_r1.setTextureOffset(0, 25).addBox(-2.575F, -0.55F, -1.75F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_right_r1.setTextureOffset(25, 12).addBox(-2.575F, -0.55F, -3.25F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_right_r1.setTextureOffset(24, 25).addBox(-2.575F, -0.55F, -5.25F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_right_r2 = new ModelRenderer(this);
			leg_fron_right_r2.setRotationPoint(-2.0F, -0.75F, 2.6F);
			legs_right.addChild(leg_fron_right_r2);
			setRotationAngle(leg_fron_right_r2, 0.0F, 0.0F, -1.309F);
			leg_fron_right_r2.setTextureOffset(20, 17).addBox(-3.4671F, -0.5326F, -0.5F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_right_r2.setTextureOffset(22, 4).addBox(-3.4671F, -0.5326F, -5.25F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_right_r3 = new ModelRenderer(this);
			leg_fron_right_r3.setRotationPoint(0.25F, 0.0F, 2.6F);
			legs_right.addChild(leg_fron_right_r3);
			setRotationAngle(leg_fron_right_r3, 0.0F, 0.0F, 0.3927F);
			leg_fron_right_r3.setTextureOffset(9, 24).addBox(-2.825F, -0.5F, -0.5F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_right_r3.setTextureOffset(25, 6).addBox(-2.825F, -0.5F, -1.75F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_right_r3.setTextureOffset(16, 25).addBox(-2.825F, -0.5F, -3.25F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_right_r3.setTextureOffset(7, 26).addBox(-2.825F, -0.5F, -5.25F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_right_r4 = new ModelRenderer(this);
			leg_fron_right_r4.setRotationPoint(-2.0F, -0.5F, 1.35F);
			legs_right.addChild(leg_fron_right_r4);
			setRotationAngle(leg_fron_right_r4, 0.0F, 0.0F, -1.309F);
			leg_fron_right_r4.setTextureOffset(0, 21).addBox(-3.2256F, -0.5973F, -0.5F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_right_r4.setTextureOffset(21, 21).addBox(-3.2256F, -0.5973F, -2.0F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			legs_left = new ModelRenderer(this);
			legs_left.setRotationPoint(1.75F, 19.5F, -2.5F);
			leg_fron_left_r1 = new ModelRenderer(this);
			leg_fron_left_r1.setRotationPoint(2.75F, 2.25F, 2.6F);
			legs_left.addChild(leg_fron_left_r1);
			setRotationAngle(leg_fron_left_r1, 0.0F, 0.0F, 1.5708F);
			leg_fron_left_r1.setTextureOffset(26, 14).addBox(-0.425F, -0.55F, -0.5F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_left_r1.setTextureOffset(14, 27).addBox(-0.425F, -0.55F, -1.75F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_left_r1.setTextureOffset(28, 0).addBox(-0.425F, -0.55F, -3.25F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_left_r1.setTextureOffset(28, 2).addBox(-0.425F, -0.55F, -5.25F, 3.0F, 1.0F, 1.0F, -0.302F, false);
			leg_fron_left_r2 = new ModelRenderer(this);
			leg_fron_left_r2.setRotationPoint(2.0F, -0.75F, 2.6F);
			legs_left.addChild(leg_fron_left_r2);
			setRotationAngle(leg_fron_left_r2, 0.0F, 0.0F, 1.309F);
			leg_fron_left_r2.setTextureOffset(9, 22).addBox(-0.5329F, -0.5326F, -0.5F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_left_r2.setTextureOffset(18, 23).addBox(-0.5329F, -0.5326F, -5.25F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_left_r3 = new ModelRenderer(this);
			leg_fron_left_r3.setRotationPoint(-0.25F, 0.0F, 2.6F);
			legs_left.addChild(leg_fron_left_r3);
			setRotationAngle(leg_fron_left_r3, 0.0F, 0.0F, -0.3927F);
			leg_fron_left_r3.setTextureOffset(26, 10).addBox(-0.175F, -0.5F, -0.5F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_left_r3.setTextureOffset(0, 27).addBox(-0.175F, -0.5F, -1.75F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_left_r3.setTextureOffset(22, 27).addBox(-0.175F, -0.5F, -3.25F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_left_r3.setTextureOffset(7, 28).addBox(-0.175F, -0.5F, -5.25F, 3.0F, 1.0F, 1.0F, -0.213F, false);
			leg_fron_left_r4 = new ModelRenderer(this);
			leg_fron_left_r4.setRotationPoint(2.0F, -0.5F, 1.35F);
			legs_left.addChild(leg_fron_left_r4);
			setRotationAngle(leg_fron_left_r4, 0.0F, 0.0F, 1.309F);
			leg_fron_left_r4.setTextureOffset(22, 19).addBox(-0.7744F, -0.5973F, -0.5F, 4.0F, 1.0F, 1.0F, -0.312F, false);
			leg_fron_left_r4.setTextureOffset(0, 23).addBox(-0.7744F, -0.5973F, -2.0F, 4.0F, 1.0F, 1.0F, -0.312F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			h_head.render(matrixStack, buffer, packedLight, packedOverlay);
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			legs_right.render(matrixStack, buffer, packedLight, packedOverlay);
			legs_left.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.legs_left.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.h_head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.h_head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.legs_right.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}

}
