package net.semppisancientvellums.entity.renderer;

import net.semppisancientvellums.entity.SmallSlaughterfishEntity;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class SmallSlaughterfishRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(SmallSlaughterfishEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelsmall_slaughterfish(), 0.5f) {

					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("semppis_ancient_vellums:textures/small_slaughterfish_java.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 4.1.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelsmall_slaughterfish extends EntityModel<Entity> {
		private final ModelRenderer body;
		private final ModelRenderer tail;
		private final ModelRenderer h_head;
		private final ModelRenderer fin_left;
		private final ModelRenderer fin_right;

		public Modelsmall_slaughterfish() {
			textureWidth = 64;
			textureHeight = 64;
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 22.0F, -7.0F);
			body.setTextureOffset(0, 0).addBox(-4.0F, -4.0F, 0.0F, 7.0F, 5.0F, 6.0F, 0.0F, false);
			body.setTextureOffset(0, 5).addBox(-0.5F, -7.0F, 1.0F, 0.0F, 3.0F, 9.0F, 0.0F, false);
			body.setTextureOffset(0, 2).addBox(-0.5F, 1.0F, 1.0F, 0.0F, 3.0F, 9.0F, 0.0F, false);
			tail = new ModelRenderer(this);
			tail.setRotationPoint(0.0F, 23.0F, -1.0F);
			tail.setTextureOffset(16, 13).addBox(-3.0F, -5.0F, 0.0F, 5.0F, 5.0F, 4.0F, 0.0F, false);
			tail.setTextureOffset(0, 23).addBox(-2.0F, -4.0F, 4.0F, 3.0F, 3.0F, 5.0F, 0.0F, false);
			tail.setTextureOffset(18, 3).addBox(-1.0F, -3.0F, 9.0F, 1.0F, 1.0F, 8.0F, 0.0F, false);
			tail.setTextureOffset(0, 26).addBox(-0.5F, -1.0F, 4.0F, 0.0F, 3.0F, 5.0F, 0.0F, false);
			tail.setTextureOffset(16, 23).addBox(-0.5F, -7.0F, 4.0F, 0.0F, 3.0F, 5.0F, 0.0F, false);
			tail.setTextureOffset(0, 12).addBox(-0.5F, -6.0F, 9.0F, 0.0F, 3.0F, 8.0F, 0.0F, false);
			tail.setTextureOffset(0, 9).addBox(-0.5F, -2.0F, 9.0F, 0.0F, 3.0F, 8.0F, 0.0F, false);
			tail.setTextureOffset(0, 21).addBox(-0.5F, -5.0F, 17.0F, 0.0F, 5.0F, 2.0F, 0.0F, false);
			h_head = new ModelRenderer(this);
			h_head.setRotationPoint(0.0F, 21.0F, -7.0F);
			h_head.setTextureOffset(27, 24).addBox(-3.0F, -3.0F, -4.0F, 5.0F, 3.0F, 4.0F, 0.0F, false);
			h_head.setTextureOffset(20, 0).addBox(-3.0F, -2.0F, -5.0F, 5.0F, 2.0F, 1.0F, 0.0F, false);
			h_head.setTextureOffset(11, 22).addBox(-3.0F, 1.0F, -5.0F, 5.0F, 1.0F, 5.0F, 0.0F, false);
			h_head.setTextureOffset(0, 1).addBox(2.0F, 0.0F, -3.0F, 0.0F, 1.0F, 3.0F, 0.0F, false);
			h_head.setTextureOffset(0, 0).addBox(-3.0F, 0.0F, -3.0F, 0.0F, 1.0F, 3.0F, 0.0F, false);
			h_head.setTextureOffset(22, 31).addBox(1.0F, -1.2F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(18, 31).addBox(-3.0F, -1.2F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(14, 31).addBox(-3.0F, 0.05F, -4.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(10, 31).addBox(1.0F, 0.05F, -4.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(31, 8).addBox(0.5F, 0.05F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(30, 12).addBox(-2.5F, 0.05F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(28, 6).addBox(-1.5F, 0.05F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(28, 3).addBox(-0.5F, 0.05F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(26, 22).addBox(0.0F, -1.2F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(11, 23).addBox(-2.0F, -1.2F, -5.0F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(20, 3).addBox(1.0F, -1.2F, -3.25F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			h_head.setTextureOffset(0, 0).addBox(-3.0F, -1.2F, -3.25F, 1.0F, 2.0F, 1.0F, -0.3F, false);
			fin_left = new ModelRenderer(this);
			fin_left.setRotationPoint(3.0F, 21.0F, -4.0F);
			fin_left.setTextureOffset(2, 5).addBox(0.0F, -1.0F, 0.0F, 1.0F, 1.0F, 0.0F, 0.0F, false);
			fin_left.setTextureOffset(18, 12).addBox(1.0F, -2.0F, 0.0F, 1.0F, 3.0F, 0.0F, 0.0F, false);
			fin_right = new ModelRenderer(this);
			fin_right.setRotationPoint(-4.0F, 21.0F, -4.0F);
			fin_right.setTextureOffset(0, 5).addBox(-1.0F, -1.0F, 0.0F, 1.0F, 1.0F, 0.0F, 0.0F, false);
			fin_right.setTextureOffset(4, 0).addBox(-2.0F, -2.0F, 0.0F, 1.0F, 3.0F, 0.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			tail.render(matrixStack, buffer, packedLight, packedOverlay);
			h_head.render(matrixStack, buffer, packedLight, packedOverlay);
			fin_left.render(matrixStack, buffer, packedLight, packedOverlay);
			fin_right.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.fin_left.rotateAngleZ = MathHelper.cos(f * 0.6662F) * f1;
			this.h_head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.h_head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.fin_right.rotateAngleZ = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
		}
	}

}
